#include "libspc.h"
#include <string.h>
#include <Be.h>
#include "pluginproto.h"
#include "def.h"


SPC_Config spc_config = {
    44100,
    16,
    2,
    1,
    1
};
SPC_ID666 *spc_id666;


static plugin_descriptor plugin={
	PLUGIN_DESCRIPTOR_MAGIC,PLUGIN_DESCRIPTOR_VERSION,
	"sp-spcplay",1, PLUGIN_IS_DECODER | PLUGIN_IS_SINGLE_CONTEXT,

	"SpcPlayer Decoder",
	"By Carwyn Jones.\n\n"
	"Based on Agawa Koji's,\n"
	"LibSpc.",
	NULL, //about,
	NULL,
	&getplugin,
	&destroyplugin
};


static decoder_plugin_ops ops={
	PLUGIN_DECODER_MAGIC,PLUGIN_DECODER_VERSION,

	NULL,
	NULL,	// close
	info,
	read,
	NULL,	// play
	NULL,	// stop
	NULL,	// setvolume
	NULL,	// setpitchandspeed
	NULL,	// seek,
	NULL,	// position,
	NULL	// bufferamount
};


static plugin_descriptor *plugs[]={
	&plugin,
	0
};

plugin_descriptor **get_plugin_list(void)
{
	return plugs;
}

static supported_type supportedtypes[]=
{
	{"audio/x-spc",	"SpcPlayer file",	"SpcPlayer file",			"spc",	NULL},
	{NULL,				NULL,				NULL,						NULL,	NULL}
};

supported_type *get_supported_types(void)
{
	return supportedtypes;
}

static void *getplugin(void **data, const char *name, const char *header, uint32 size, plugin_info *info)

{
	
	if(!header || strncmp("SNE",header, 3))
	
	return NULL;
	*data=new SpcPlugin(name);
	return &ops;

}

void destroyplugin(void *ops,void *_spc)
{
	SpcPlugin *spc=(SpcPlugin*)_spc;
	delete spc;
}


int32 read(void *_spc,char *buf, ulong count)
{

	SpcPlugin *spc=(SpcPlugin*)_spc;
	return spc->Read(buf, count);

}

SpcPlugin::~SpcPlugin()
{
	SPC_close();
}

static status_t info(void *_spc, file_info *info)
{
char newname[100];

	if(spc_id666) {
	sprintf(newname, "%s - %s", spc_id666->gametitle,spc_id666->songname);
	}
	
	if (!strcmp(newname, " - ")) {
	strcpy(info->name,"");
	} else {
	
		strcpy(info->name,newname);
	}
	
	strcpy(info->typedesc,"spc");
	strcpy(info->mimetype,"audio/x-spc"); 
	info->samplerate=44100;
	info->bitrate=0;
	info->numchannels=2;
	info->granularity=4096;
	info->framecount=0x7fffffff;
	info->samplesize=2;
	if(B_HOST_IS_LENDIAN)
		info->byteorder=B_LITTLE_ENDIAN;
	else
		info->byteorder=B_BIG_ENDIAN;
	info->sampleformat=B_LINEAR_SAMPLES;
	info->flags=PLUGIN_FILELENGTH_UNKNOWN | PLUGIN_NO_ELAPSEDTIME;

return B_OK;
}


SpcPlugin::SpcPlugin(const char *name)
{
	printf("inconstructor\n");
	spc_id666 = SPC_get_id666(name);
	size = SPC_init(&spc_config);
	if(!SPC_load(name))

	return;


}

int32 SpcPlugin::Read(char *buf, ulong numframes)
{
	uint32 numread = 0;
	
	do {
	SPC_update((uint8 *)buf);
	buf+=size;
	numread +=size/4;
	if((numread) !=size/4)snooze(6500);
	} while (numread+size/4<numframes);
	
return numread;
}














